clear all;
clc;

close all;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% GENETIC ALGORITHM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

noParams = 12;
initscores(1,:)  = [0 1];       % connection from unit 1 to 1
initscores(2,:)  = [0 1];       % 1 to 2
initscores(3,:)  = [0 1];       % 1 to 3
initscores(4,:)  = [0 1];       % 2 to 1
initscores(5,:)  = [0 1];       % 2 to 2
initscores(6,:)  = [0 1];       % 2 to 3
initscores(7,:)  = [0 1];       % 3 to 1
initscores(8,:)  = [0 1];       % 3 to 2
initscores(9,:)  = [0 1];       % 3 to 3

initscores(10,:) = [0 1];       % baseline 1
initscores(11,:) = [0 1];       % baseline 2
initscores(12,:) = [0 1];       % baseline 3

genNo   = 75;                   %generation number
popnNo  = 200;                  %population
gen_lim = 25;                   %maximum n. of stalled generation
fit_lim = 2;                    %lower threashold of optimization


%%
start_pop=rand(1,noParams);

%full description of function options: http://uk.mathworks.com/help/gads/gaoptimset.html
options = gaoptimset(                               ...
    'EliteCount',2,                                 ... % The n. of best fitness values guaranteed to survive.
    'MutationFcn',{@mutationadaptfeasible},         ... @mutationgaussian - appropriate for unconstrained minimization problems
                                                    ... @mutationadaptfeasible - constrained minimization problem
    'PopInitRange',[0;1],                           ...
    'InitialPop', start_pop,                        ...
    'CreationFcn',@gacreationlinearfeasible,        ... @gacreationuniform - creates a random initial population with a uniform distribution. Default when there are no linear constraints.
                                                    ... @gacreationlinearfeasible - Default when there are linear constraints and no integer constraints. Creates a random initial population that satisfies all bounds and linear constraints.
                                                    ... 
    'PopulationSize',popnNo,                        ...
    'Generations',genNo,                            ...
    'StallGenLimit',gen_lim,                        ...
    'FitnessLimit',fit_lim,                         ...
    'Display','iter',                               ...
    'PlotFcns',{@gaplotscorediversity, @gaplotbestf});% 'PlotFcns', {@gaplotbestf,@gaplotbestindiv,
                                                     % @gaplotscorediversity, @gaplotgenealogy, ...
                                                     % @gaplotscores, @gaplotrange, ...
                                                     % @gaplotselection});


[solution_data, fval, exitflag, output, finalpop, scores] = ga(@fitnessfun,noParams,                ...
   [],[],                 ...      % inequality constraints
   [],[],                 ...      % equality constraints
   initscores(:,1),       ...      % lower bound
   initscores(:,2),       ...      % upper bound
   [],                    ...      % nonlinear constraints
   options);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%% SAVE DATA %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

save ga_history.mat;