clear all
close all

%% SEED to control pseudo-random variables
rng(5)
%%

tic

SECS=30;
dt=50;
T=SECS*1000/dt;
dim=3;             %number of units per layer

all_units.potential = zeros(T,dim);
all_units.activity  = zeros(T,dim);

input = zeros(T,dim);
da    = zeros(T,1);

%% load the solution of the ganetic algoritm to test it
load('ga_history.mat', 'solution_data')
genType=solution_data;

% genType=[0.4 0.5 0.3 ...
%          0.3 0.5 0.5 ...
%          0.6 0.5 0.5 ...
%          ...
%          0.5 0.2 0.4]; %configuration for attractor state and error=0

parameters = param_scale(genType);

%matrix of lateral connections used in all layers
all_units.self_w =[parameters.w_11 parameters.w_12 parameters.w_13
                   parameters.w_21 parameters.w_22 parameters.w_23
                   parameters.w_31 parameters.w_32 parameters.w_33];
               
%decay used for all units
all_units.decay=[300 600 1200];

%noise activation per layer
all_units.noise=0.0;            %if noise=1 -> bl=bl+-0.1
               
%baselines per layer
all_units.baseline = [parameters.bl1 parameters.bl2 parameters.bl3];

%thresholds per layer
all_units.th_out =0;

%dopamine parameter per structure
all_units.epsilon=1;     % if =0 the input is not processed without dopamine
all_units.lambda=0;      % if =0 dopamine has no effect

for t=2:T
 
    all_units = leaky_step(t, dt,  all_units, input(t-1,:), da(t-1));
    
    %uncomment the following line to activate random noise
    %all_units.activity(t,:)=all_units.activity(t,:)+(rand(1,3)/5)-0.1;
end

overall_error = exp_error(all_units.activity, T);
disp(overall_error);
toc
plotting